﻿#encoding: UTF-8

import math
from PIL import ImageDraw, ImageFont, Image
from random import random, randint
from datetime import datetime, timedelta
from time import gmtime, strftime

class screen_en57akl(abstractscreenrenderer):
	def __init__(self, lookup_path):
		# definicje kolorow
		self.czarny = (0,0,0)
		self.blekitny=(155,249,255)
		self.niebieski=(196,236,255)
		self.szary=(51,51,51)
		self.zielony=(58,202,27)
		self.czerwony=(255,0,0)
		self.zolty=(255,204,0)
		self.bialy=(255,255,255)
		self.pomaranczowy = (255,128,40)
		self.niebieski_boot = (71,121,176)
		self.zielonastrzalka = (0,252,0)	
		self.niebieskastrzalka = (0,0,250)		
		self.zoltastrzalka = (248,252,0)		
		self.szary2 = (40,44,40)
		# wczytanie obrazka
		self.tlo = self.openimage(lookup_path + "cab/ekran")
		lookup_path = lookup_path + "screen/"
		self.podklad = None		
		self.podklad_alarm = None	
		self.ramki1 = None
		self.ramki2 = None	
		self.podklad_hamulec = Image.open(lookup_path + "podklad_hamulec.png")	
		self.podklad_drzwi = Image.open(lookup_path + "podklad_drzwi.png")	
		self.reflektory = Image.open(lookup_path + "podklad_reflektory.png")			
		self.drzwi_blad_can = Image.open(lookup_path + "drzwi_blad_can.png")				
		self.podklad_drzwi_ezt2 = Image.open(lookup_path + "drzwi_ezt2.png")				
		self.ezt  = Image.open(lookup_path + "ezt.png")
		self.WN_off  = Image.open(lookup_path + "WN_off.png")
		self.WS_off  = Image.open(lookup_path + "WS_off.png")
		self.WS_gotowosc  = Image.open(lookup_path + "WS_gotowosc.png")
		self.przetwornica_off  = Image.open(lookup_path + "przetwornica_off.png")
		self.bateria_off  = Image.open(lookup_path + "bateria_off.png")
		self.falownik_off  = Image.open(lookup_path + "falownik_off.png")
		self.sprezarka_off  = Image.open(lookup_path + "sprezarka_off.png")
		self.M1M2_on  = Image.open(lookup_path + "M1M2_on.png")
		self.M3M4_on  = Image.open(lookup_path + "M3M4_on.png")
		self.M1M2_off  = Image.open(lookup_path + "M1M2_off.png")
		self.M3M4_off  = Image.open(lookup_path + "M3M4_off.png")		
		self.M1M2_awaria  = Image.open(lookup_path + "M1M2_awaria.png")
		self.M3M4_awaria  = Image.open(lookup_path + "M3M4_awaria.png")	
		self.M1M2_gotow  = Image.open(lookup_path + "M1M2_gotowy.png")
		self.M3M4_gotow  = Image.open(lookup_path + "M3M4_gotowy.png")			
		self.WN_on  = Image.open(lookup_path + "WN_on.png")
		self.WS_on  = Image.open(lookup_path + "WS_on.png")
		self.przetwornica_on  = Image.open(lookup_path + "przetwornica_on.png")
		self.bateria_on  = Image.open(lookup_path + "bateria_on.png")
		self.falownik_on  = Image.open(lookup_path + "falownik_on.png")
		self.sprezarka_on  = Image.open(lookup_path + "sprezarka_on.png")
		self.sprezarka_idle  = Image.open(lookup_path + "sprezarka_idle.png")
		self.awaria_off  = Image.open(lookup_path + "awaria_off.png")
		self.awaria_on  = Image.open(lookup_path + "awaria_on.png")
		self.hamulec_off  = Image.open(lookup_path + "hamulec_off.png")
		self.hamulec_on  = Image.open(lookup_path + "hamulec_on.png")
		self.poslizg_on  = Image.open(lookup_path + "poslizg_on.png")
		self.poslizg_off  = Image.open(lookup_path + "poslizg_off.png")
		self.klima_on  = Image.open(lookup_path + "klima_on.png")
		self.klima_off  = Image.open(lookup_path + "klima_off.png")
		self.grzanie_on  = Image.open(lookup_path + "grzanie_on.png")
		self.grzanie_off  = Image.open(lookup_path + "grzanie_off.png")
		self.boot1 = Image.open('./textures/tabor/python/medcom_en57/bootowanie_medcom_1.png')
		self.boot2 = Image.open('./textures/tabor/python/medcom_en57/bootowanie_medcom_2.png')
		self.boot3 = Image.open('./textures/tabor/python/medcom_en57/bootowanie_medcom_3.png')
		self.boot4 = Image.open('./textures/tabor/python/medcom_en57/bootowanie_medcom_4.png')
		self.boot5 = Image.open('./textures/tabor/python/medcom_en57/bootowanie_medcom_5.png')		
		# wczytanie czcionki
		czcionka = "./fonts/verdanab.ttf"
		czcionka2 = "./fonts/verdana.ttf"		
		self.font = ImageFont.truetype( czcionka, 20)
		self.sredni_font = ImageFont.truetype( czcionka, 17)
		self.maly_font = ImageFont.truetype( czcionka, 15)
		self.bardzo_maly_font = ImageFont.truetype( czcionka, 12)
		self.polduzy_font = ImageFont.truetype( czcionka, 27)
		
		self.font2 = ImageFont.truetype( czcionka2, 20)
		self.sredni_font2 = ImageFont.truetype( czcionka2, 17)
		self.maly_font2 = ImageFont.truetype( czcionka2, 15)
		self.bardzo_maly_font2 = ImageFont.truetype( czcionka2, 12)
		self.polduzy_font2 = ImageFont.truetype( czcionka2, 27)
		
		self.fontv16b = ImageFont.truetype('./fonts/verdanab.ttf', 16)
		self.konsola = ImageFont.truetype('./fonts/unifont.ttf', 18)		
		
		self.kilometry = (random()*300000)+5000
		self.last_time_update = 0
		self.dzis = datetime.now().timetuple().tm_yday
		self.rok = datetime.now().year
		self.last_hour = 10
		self.losowanie_liniahamulca = randint(0, 30)
		self.losowanie_sprawnosc_drzwi = randint(0, 45)
		self.aktyw = 0
		self.pasek = 0
		self.temp12 = (random()*21) + 18
		self.temp34 = (random()*19) + 16
		self.temp56 = (random()*20) + 14
		self.temp78 = (random()*18) + 17
		self.tryb = 0		
		self.stan1 = False
		self.stan2 = False
		self.stan4 = False
		self.stan5 = False
		self.stan6 = False
		self.klikniete = -1
		self.aktywm1m2 = 0		
		self.aktywm3m4 = 0	
		self.aktyw2m1m2 = 0		
		self.aktyw2m3m4 = 0		
		self.aktyw3m1m2 = 0		
		self.aktyw3m3m4 = 0				

	def _render(self, state):
		if self.podklad == None and self.podklad_alarm == None and self.ramki1 == None and self.ramki2 == None:
			if int(state["akm"]) == 1:
				self.podklad = Image.open('./dynamic/pkp/en57akl_v1/screen/podklad_akm.png')
				self.podklad_alarm = Image.open('./dynamic/pkp/en57akl_v1/screen/podklad_alarm_akm.png')	
				self.ramki1 = Image.open('./dynamic/pkp/en57akl_v1/screen/ramki1_akm.png')	
				self.ramki2 = Image.open('./dynamic/pkp/en57akl_v1/screen/ramki2_akm.png')					
			if int(state["akm"]) == 0:
				self.podklad = Image.open('./dynamic/pkp/en57akl_v1/screen/podklad.png')
				self.podklad_alarm = Image.open('./dynamic/pkp/en57akl_v1/screen/podklad_alarm.png')
				self.ramki1 = Image.open('./dynamic/pkp/en57akl_v1/screen/ramki1.png')	
				self.ramki2 = Image.open('./dynamic/pkp/en57akl_v1/screen/ramki2.png')					
		
		tlo = self.tlo.copy()
		dt=0
		# Liczenie pojazdow
		unit_no = state['unit_no']
		car_no = state['car_no']
		if (car_no == 3) or (car_no > 6):
			pojazdy = 1
		if (unit_no == 2) and (car_no == 6):
			pojazdy = 2
		if (car_no > 6):
			pojazdy = 3
		if (car_no > 9):
			pojazdy = 4

		napiecie = state['eimp_c1_uhv']
		napiecie2 = state['eimp_c2_uhv']
		velocity = state['velocity']
		speed = float(velocity)
		if speed > 200:
			speed = 200
		temp = state['air_temperature']
		direction = state['direction']
		seconds = state['seconds']
		minutes = state['minutes']
		hours = state['hours']
		dir_brake = state['dir_brake']
		indir_brake = state['indir_brake']
		brakes_1_spring_active = state['brakes_1_spring_active']
		brakes_3_spring_active = state['brakes_3_spring_active']
		brakes_4_spring_active = state['brakes_4_spring_active']
		brakes_6_spring_active = state['brakes_6_spring_active']
		spring_brake = ((brakes_1_spring_active == 1) | (brakes_3_spring_active == 1))
		dir_or_indir_brake_pn = (dir_brake | indir_brake )
		dir_or_indir_brake = (dir_or_indir_brake_pn | spring_brake)
		doors_1 = state['doors_1']
		doors_2 = state['doors_2']
		doors_3 = state['doors_3']
		doors_ezt1 = (doors_1 | doors_2 | doors_3)
		doors_4 = state['doors_4']
		doors_5 = state['doors_5']
		doors_6 = state['doors_6']
		doors_ezt2 = (doors_4 | doors_5 | doors_6)
		eimp_u1_pf = state['eimp_u1_pf']
		eimp_u1_pr = state['eimp_u1_pr']
		eimp_u2_pf = state['eimp_u2_pf']
		eimp_u2_pr = state['eimp_u2_pr']
		eimp_c1_ms = state['eimp_c1_ms']
		eimp_c2_ms = state['eimp_c2_ms']
		eimp_c1_conv = state['eimp_c1_conv']
		eimp_c2_conv = state['eimp_c2_conv']
		eimp_c1_fuse = state['eimp_c1_fuse']
		ws_gotowosc = state['main_ready']
		gotowy_do_jazdy = ((doors_ezt1 == 0)&(dir_or_indir_brake == 0)&((eimp_c1_ms&eimp_c1_conv) == 1)&(eimp_c1_fuse == 0)&(direction != 0)&((state['pantpress']) > 3.5))
		blokada_drzwi = (state['door_lock'] == 0)
		linia_hamulca = (state['eimp_pn1_bc']>1.2)
		linia_hamulca_wylosowana = (self.losowanie_liniahamulca == 0)
		sprawnosc_drzwi_wylosowana = (self.losowanie_sprawnosc_drzwi == 0 and doors_1 | doors_2 | doors_3)
		sprezarka_pomocnicza = (state['pant_compressor'] == 1)
		komunikacja_can = (pojazdy > 2)
		went_ft1 = (self.aktywm1m2>=11) and (self.aktywm1m2<13)	
		went_ft2 = (self.aktywm3m4>=11) and (self.aktywm3m4<13)	
		went2_ft1 = (self.aktyw2m1m2>=11) and (self.aktyw2m1m2<13)	
		went2_ft2 = (self.aktyw2m3m4>=11) and (self.aktyw2m3m4<13)		
		went3_ft1 = (self.aktyw3m1m2>=11) and (self.aktyw3m1m2<13)	
		went3_ft2 = (self.aktyw3m3m4>=11) and (self.aktyw3m3m4<13)		
		lights_front = state['lights_train_front']
		lights_rear = state['lights_train_rear']			
		temp_zew = float(state['air_temperature'])			
		
		# czas
		if seconds != self.last_time_update:
			dt = seconds - self.last_time_update
			if dt < 0:
				dt+=60
			self.kilometry += dt*speed * 0.0002778
			self.last_time_update = seconds
		czas = str(hours) + ":" 
		if minutes<10:
			czas = czas + "0" + str(minutes) + ":"
		else:
			czas = czas + str(minutes) + ":"
		if seconds<10:
			czas = czas + "0" +str(seconds)
		else:
			czas = czas + str(seconds)
			
		# data
		if self.last_hour == 23 and hours == 0:
			self.dzis = self.dzis+1 # wlasnie wybila polnoc
		self.last_hour = hours
		data = datetime(self.rok, 1, 1) + timedelta(self.dzis - 1)
		data = data.strftime("%d/%m/%Y")	

		# kopia obrazka na potrzeby tego jednego renderowania
		obrazek = self.podklad.copy()
		# chcemy rysowac po teksturze pulpitu
		draw = ImageDraw.Draw(obrazek)
		if (state['battery'] or state['converter']):
				self.aktyw += dt
				if self.aktyw<21:
					if self.aktyw >= 0:
						obrazek.paste(self.boot1, (0,0), self.boot1)
					if self.aktyw >= 2:
						obrazek.paste(self.boot2, (0,0), self.boot2)
					if self.aktyw >= 3:
						draw.text((5,260), 'GRUB Loading stage1.5', fill=self.bialy, font=self.konsola)
					if self.aktyw >= 4:
						draw.text((5,320), 'GRUB loading, please wait...', fill=self.bialy, font=self.konsola)	
					if self.aktyw >= 5:
						obrazek.paste(self.boot3, (0,0), self.boot3)
					if self.aktyw >= 6:
						draw.rectangle((0, 0, 798, 606), fill=self.czarny)
					if (self.aktyw >= 6 and self.aktyw < 8):
						draw.text((5,70), 'Starting up ...', fill=self.bialy, font=self.konsola)
					if (self.aktyw >= 7 and self.aktyw < 8):
						draw.text((5,100), 'Uncompressing Linux... Ok, booting the kernel.', fill=self.bialy, font=self.konsola)	
					if self.aktyw >= 8:
						obrazek.paste(self.boot4, (0,0), self.boot4)	
						draw.text((5,230), 'Starting up ...', fill=self.bialy, font=self.konsola)
						draw.text((5,245), 'Uncompressing Linux... Ok, booting the kernel.', fill=self.bialy, font=self.konsola)	
					if self.aktyw >= 9:
						self.pasek += dt
						obrazek.paste(self.boot5, (0,0), self.boot5)	
						draw.rectangle((170,331,170 + 89 * self.pasek,358), fill=self.niebieski_boot)
					if self.aktyw >= 14:
						draw.rectangle((0, 0, 798, 606), fill=self.czarny)
						draw.text((5,100), 'Starting up ...', fill=self.bialy, font=self.konsola)
						draw.text((5,115), 'Uncompressing Linux... Ok, booting the kernel.', fill=self.bialy, font=self.konsola)	
						draw.text((5,130), 'INIT: version 2.86 booting', fill=self.bialy, font=self.konsola)	
						draw.text((5,160), 'Please wait: booting...', fill=self.bialy, font=self.konsola)	
						draw.text((5,175), 'Starting the hotplug events dispatcher udevd', fill=self.bialy, font=self.konsola)
						draw.text((5,190), 'Synthesizing the initial hotplug events', fill=self.bialy, font=self.konsola)
						draw.text((5,205), 'Waiting for /dev to be fully populated', fill=self.bialy, font=self.konsola)
						draw.text((5,235), 'Setting up IP spoofing protection: rp_filter.', fill=self.bialy, font=self.konsola)
						draw.text((5,250), 'Configuration network interfaces... done.', fill=self.bialy, font=self.konsola)
						draw.text((5,275), 'Setting watchdog timeout', fill=self.bialy, font=self.konsola)
						draw.text((5,290), 'Setting audio volumes', fill=self.bialy, font=self.konsola)
						draw.text((5,305), 'Setting up CAN-bus drivers', fill=self.bialy, font=self.konsola)
					if self.aktyw >= 15:
						draw.rectangle((0, 0, 798, 606), fill=self.czarny)
					if self.aktyw >= 17:
						draw.line([(392,352),(409,335)], fill=self.bialy, width=3)
						draw.line([(392,335),(409,352)], fill=self.bialy, width=3)
						draw.line([(394,350),(407,340)], fill=self.czarny, width=1)
						draw.line([(394,340),(407,350)], fill=self.czarny, width=1)
					if self.aktyw >= 20:
						draw.rectangle((0, 0, 798, 606), fill=self.szary)
				else:				
					if state['universal1'] != self.stan1:
						self.klikniete = 1
					if state['universal2'] != self.stan2:
						self.klikniete = 2
					if state['universal4'] != self.stan4:
						self.klikniete = 4
					if state['universal5'] != self.stan5:
						self.klikniete = 5
					if state['universal6'] != self.stan6:
						self.klikniete = 6						

					if (self.klikniete == 1): #status glowny skądkolwiek
						self.tryb = 0
					elif (self.tryb == 4) or (self.klikniete == 4): # na drzwi albo z drzwi donikąd
						self.tryb = 4 # drzwi
					elif (self.klikniete == 2): # na alarmy
						self.tryb = 2 # alarmy
					elif (self.klikniete == 5) and int(state["akm"]) == 0: # na hamulec
						self.tryb = 6 # hamulec					
					elif (self.klikniete == 6) and int(state["akm"]) == 0: # na reflektory
						self.tryb = 5 # reflektory
						
					draw.rectangle((0, 0, 798, 606), fill=self.szary)
					if state['cabactive'] == 1 and state['cab'] == 1 or state['cabactive'] == -1 and state['cab'] == -1: 	
						if (self.tryb == 0) or (self.tryb == 2):	
							obrazek.paste(self.podklad, (0,0), self.podklad)									
							# kierunek jazdy
							if direction == 1:
								draw.polygon([(294, 87), (305, 50), (294, 53), (307, 28), (320, 53), (309, 50), (320, 87)],fill=self.zielony) # strzalka kierunkowa naprzod

							if direction == -1:
								draw.polygon([(294, 114), (305, 152), (294, 149), (307, 174), (320, 149), (309, 152), (320, 114)],fill=self.zielony) # strzalka kierunkowa w tyl

							# slupek napiecia i jego wartosc
							if napiecie < 0:
								napiecie = 0
							pos = 177 - (napiecie * 150 / 5000)-2
							draw.rectangle((485,pos,469,176), fill=self.zolty)
							napiecie1 = napiecie/1000
							draw.text((455, 180), '%.1f' % napiecie1, fill=self.zolty, font=self.maly_font)

							# slupek procentu siły zadanej jazdy
							sila = state['eimp_t_pdt']
							pos = 176 - (sila * 150)-2
							draw.rectangle((20,176,36,pos), fill=self.zolty)
							sila=sila*100
							self.print_fixed_with(draw, '%d' % sila, (4, 178), 3, self.maly_font, self.zolty)

							# napięcie NN
							self.print_fixed_with(draw, '%d' % state['eimp_c1_cv'], (706,122), 3, self.font, self.zolty)

							# prędkość
							self.print_fixed_with(draw, '%d' % speed, (706,172), 3, self.font, self.zolty)

							draw.text((708,4), czas, fill=self.bialy, font=self.sredni_font2)

							draw.text((686,30), data, fill=self.bialy, font=self.sredni_font2)
							
							if state['slip_2'] or state['slip_4']:#poslizg
								obrazek.paste(self.poslizg_on,(369,2),self.poslizg_on)
							else:
								obrazek.paste(self.poslizg_off,(369,2),self.poslizg_off)

							if dir_or_indir_brake:#hamulec
								obrazek.paste(self.hamulec_on,(369,67),self.hamulec_on)
							else:
								obrazek.paste(self.hamulec_off,(369,67),self.hamulec_off)

							#awaria
							if state['door_lock'] == 0 or state['eimp_c1_inv1_allow'] == 0 or state['eimp_c1_inv1_error'] == 1 or state['eimp_c1_inv2_allow'] == 0 or state['eimp_c1_inv2_error'] == 1 or went_ft1 or went_ft2 or state['fuse'] or state['converter_overload'] or linia_hamulca and linia_hamulca_wylosowana or blokada_drzwi: 								
								obrazek.paste(self.awaria_on,(369,132),self.awaria_on)
							else:
								obrazek.paste(self.awaria_off,(369,132),self.awaria_off)

							if state['eimp_c1_heat']:#grzanie
								obrazek.paste(self.grzanie_on,(730,54),self.grzanie_on)
							else:
								obrazek.paste(self.grzanie_off,(730,54),self.grzanie_off)

							# if state['']:#klimatyzacja
								# obrazek.paste(self.klima_on,(680,54),self.klima_on)
							# else:
							obrazek.paste(self.klima_off,(680,54),self.klima_off)
							
					#	if (self.tryb == 0):
					
							# seria i model
							code = (state['name'])[:12]

							self.print_center(draw, code, 710,514, self.font2, self.bialy)

							# kabina a aktywna
							cab = state['cab']
							if cab == 1:
								self.print_center(draw, "Kabina A aktywna", 711,420, self.bardzo_maly_font2, self.bialy)
							if cab == -1:
								self.print_center(draw, "Kabina B aktywna", 711,420, self.bardzo_maly_font2, self.bialy)
							# komunikaty stanu pojazdu
							if (gotowy_do_jazdy&(velocity < 0.5 )):
								komunikat2 = 'Gotowy do jazdy' #dodać warunki na ezt 2 i 3; self.zielony
								komunikat2_kolor = self.zielony
							elif ((dir_brake)&((state['brake_op_mode_flag']) == 8)&(velocity > 0.5 )):
								komunikat2 = u'Hamowanie ED' #żólty
								komunikat2_kolor = self.zolty
							elif (gotowy_do_jazdy&(velocity > 0.5 )&(state['eimp_t_fdt'] == 0)):
								komunikat2 = 'Wybieg' #brak zadanej mocy, brak hamowania, jedzie; zółty
								komunikat2_kolor = self.zolty
							else:
								komunikat2 = ''
								komunikat2_kolor = self.bialy

							if (dir_or_indir_brake&(velocity < 0.5 )):
								komunikat = u'Blokada napędu' #zahamowany i stoi; self.czerwony
								komunikat_kolor = self.czerwony
							elif (((state['door_lock']) == 0)&(velocity > 0.5)):
								komunikat = 'Jazda awaryjna' #(door_signaling==false)&(engine_damaged==false); self.czerwony
								komunikat_kolor = self.czerwony
							elif (gotowy_do_jazdy&(velocity > 0.5 )):
								komunikat = u'Napęd sprawny' #jak "gotowy do jazdy" tylko jedzie; self.zielony
								komunikat_kolor = self.zielony
							elif (False):
								komunikat = u'Napęd nieaktywny' #brak rozrządu prawdopodobnie; czerowny
								komunikat_kolor = self.czerwony
							else:
								komunikat = ''
								komunikat_kolor = self.bialy
							self.print_center(draw, komunikat, 711,443, self.fontv16b, komunikat_kolor)
							self.print_center(draw, komunikat2, 711,477, self.fontv16b, komunikat2_kolor)




							### komunikaty duze
							if int(state["akm"]) == 1:		
								self.czerwony_alarm=(255,255,255)	
								self.zolty_alarm=(255,255,255)								
							if int(state["akm"]) == 0:							
								self.czerwony_alarm=(255,0,0)
								self.zolty_alarm=(255,204,0)
						

							messages = [
								{"name":u"EZT1: Brak kierunku jazdy","color":self.zolty_alarm,"cond":direction == 0 and state['eimp_c1_ms'] != 0},
								{"name":u"EZT1: Wyzeruj nastawnik kierunku","color":self.zolty_alarm,"cond":state['eimp_c1_ms'] == 0 and direction != 0 and speed == 0},
								{"name":u"EZT1: Wyzeruj nastawnik jazdy","color":self.zolty_alarm,"cond":state['eimp_c1_ms'] == 0 and state["mainctrl_pos"] != 0},								
								{"name":u"EZT1: Niskie ciśnienie pantografów","color":self.czerwony_alarm,"cond":state["pantpress"] < 2.5},
								{"name":u"EZT1: Blokada napędu od pneumatyki","color":self.czerwony_alarm,"cond":dir_or_indir_brake_pn and velocity < 0.5},
								{"name":u"EZT2: Blokada napędu od pneumatyki","color":self.czerwony_alarm,"cond":pojazdy >= 2 and dir_or_indir_brake_pn and velocity < 0.5},
								#{"name":u"EZT3: Blokada napędu od pneumatyki","color":self.czerwony_alarm,"cond":pojazdy >= 3 and dir_or_indir_brake_pn and velocity < 0.5},
								{"name":u"EZT1: Otwarte drzwi - strona prawa","color":self.bialy,"cond":(((cab == 1) & (state["doors_r_1"] or state["doors_r_2"] or state["doors_r_3"])) | ((cab == -1) & (state["doors_l_1"] or state["doors_l_2"] or state["doors_l_3"])))},
								{"name":u"EZT2: Otwarte drzwi - strona prawa","color":self.bialy,"cond":(((cab == 1) & (state["doors_r_4"] or state["doors_r_5"] or state["doors_r_6"])) | ((cab == -1) & (state["doors_l_4"] or state["doors_l_5"] or state["doors_l_6"])))},
								#{"name":u"EZT3: Otwarte drzwi - strona prawa","color":self.bialy,"cond":(((cab == 1) & (state["doors_r_7"] or state["doors_r_8"] or state["doors_r_9"])) | ((cab == -1) & (state["doors_l_7"] or state["doors_l_8"] or state["doors_l_9"])))},
								{"name":u"EZT1: Otwarte drzwi - strona lewa","color":self.bialy,"cond":(((cab == 1) & (state["doors_l_1"] or state["doors_l_2"] or state["doors_l_3"])) | ((cab == -1) & (state["doors_r_1"] or state["doors_r_2"] or state["doors_r_3"])))},
								{"name":u"EZT2: Otwarte drzwi - strona lewa","color":self.bialy,"cond":(((cab == 1) & (state["doors_l_4"] or state["doors_l_5"] or state["doors_l_6"])) | ((cab == -1) & (state["doors_r_4"] or state["doors_r_5"] or state["doors_r_6"])))},
								#{"name":u"EZT3: Otwarte drzwi - strona lewa","color":self.bialy,"cond":(((cab == 1) & (state["doors_l_7"] or state["doors_l_8"] or state["doors_l_9"])) | ((cab == -1) & (state["doors_r_7"] or state["doors_r_8"] or state["doors_r_9"])))},
								{"name":u"EZT1: Próba szczelności","color":self.czerwony_alarm,"cond":state["brake_op_mode_flag"] == 1},
								{"name":u"EZT2: Próba szczelności","color":self.czerwony_alarm,"cond":state["brake_op_mode_flag"] == 1 and pojazdy == 2 },
								{"name":u"EZT1: Niskie ciśnienie w przewodzie zasilającym","color":self.czerwony_alarm,"cond":state["eimp_pn2_sp"] < 5.7},
								{"name":u"EZT2: Niskie ciśnienie w przewodzie zasilającym","color":self.czerwony_alarm,"cond":state["eimp_pn4_sp"] < 5.7 and pojazdy == 2 },
								{"name":u"Tempomat aktywny","color":self.bialy,"cond":state["scndctrl_pos"] > 0},
								{"name":u"EZT1: Przekroczona górna granica napięcia trakcji","color":self.czerwony_alarm,"cond":napiecie > 4500},
								{"name":u"EZT2: Przekroczona górna granica napięcia trakcji","color":self.czerwony_alarm,"cond":napiecie2 > 4500 and pojazdy == 2},
								{"name":u"EZT1: Niskie napięcie baterii","color":self.czerwony_alarm,"cond":state["eimp_c1_cv"] < 75},
								{"name":u"EZT2: Niskie napięcie baterii","color":self.czerwony_alarm,"cond":state["eimp_c2_cv"] < 75 and pojazdy == 2 },
								{"name":u"EZT1: Odblokuj urządzenia nadmiarowe","color":self.czerwony_alarm,"cond":state["eimp_c1_fuse"]},
								{"name":u"EZT2: Odblokuj urządzenia nadmiarowe","color":self.czerwony_alarm,"cond":state["eimp_c2_fuse"]},
								{"name":u"EZT1: Wyłącznik szybki gotowy do załączenia","color":self.bialy,"cond":(state['main_ready'])},
								{"name":u"EZT2: Wyłącznik szybki gotowy do załączenia","color":self.bialy,"cond":(state['main_ready']) and pojazdy == 2 and napiecie2 > 2000},
								{"name":u"EZT1: Załączony hamulec parkingowy na wagonie Ra","color":self.czerwony_alarm,"cond":brakes_1_spring_active},
								{"name":u"EZT1: Załączony hamulec parkingowy na wagonie Rb","color":self.czerwony_alarm,"cond":brakes_3_spring_active},
								{"name":u"EZT2: Załączony hamulec parkingowy na wagonie Ra","color":self.czerwony_alarm,"cond":brakes_4_spring_active and pojazdy == 2 },
								{"name":u"EZT2: Załączony hamulec parkingowy na wagonie Rb","color":self.czerwony_alarm,"cond":brakes_6_spring_active and pojazdy == 2 },
								{"name":u"EZT1: Przerwana pętla bezpieczeństwa","color":self.czerwony_alarm,"cond":blokada_drzwi},
								{"name":u"EZT2: Przerwana pętla bezpieczeństwa","color":self.czerwony_alarm,"cond":blokada_drzwi and pojazdy == 2 },
								{"name":u"EZT1: Błąd linii hamulca","color":self.czerwony_alarm,"cond":linia_hamulca and linia_hamulca_wylosowana and int(state["akm"]) == 0},
								{"name":u"EZT1: Hamowanie pojazdu","color":self.czerwony_alarm,"cond":linia_hamulca and linia_hamulca_wylosowana and int(state["akm"]) == 0},
								{"name":u"EZT1: Brak sprawności sterownika drzwi automatycznych","color":self.czerwony_alarm,"cond":sprawnosc_drzwi_wylosowana},
								{"name":u"EZT1: Sprężarka pantografowa pracuje","color":self.bialy,"cond":sprezarka_pomocnicza},
								{"name":u"EZT2: Sprężarka pantografowa pracuje","color":self.bialy,"cond":sprezarka_pomocnicza and pojazdy == 2},
								{"name":u"EZT3: Brak komunikacji CAN z trzecim EZT","color":self.czerwony_alarm,"cond":state['car_no']>=9},
								{"name":u"EZT2: Brak komunikacji CAN z drugim EZT","color":self.czerwony_alarm,"cond":state['car_no']>=7},
								{"name":u"EZT1: Poślizg","color":self.czerwony_alarm,"cond":state['slip_2']},
								{"name":u"EZT1: Wyłączony falownik 1","color":self.bialy,"cond":state['eimp_c1_inv1_allow'] == 0 or state['eimp_c1_inv1_error'] == 1},		
								{"name":u"EZT1: Wyłączony falownik 2","color":self.bialy,"cond":state['eimp_c1_inv2_allow'] == 0 or state['eimp_c1_inv2_error'] == 1},	
								{"name":u"EZT2: Wyłączony falownik 1","color":self.bialy,"cond": pojazdy == 2 and state['eimp_c2_inv1_allow'] == 0 or state['eimp_c1_inv1_error'] == 1},
								{"name":u"EZT2: Wyłączony falownik 2","color":self.bialy,"cond": pojazdy == 2 and state['eimp_c2_inv2_allow'] == 0 or state['eimp_c1_inv2_error'] == 1},	
								{"name":u"EZT1: Niesprawne wentylatory FT1","color":self.czerwony_alarm,"cond":went_ft1},		
								{"name":u"EZT1: Niesprawne wentylatory FT2","color":self.czerwony_alarm,"cond":went_ft2},	
								{"name":u"EZT2: Niesprawne wentylatory FT1","color":self.czerwony_alarm,"cond":went2_ft1 and pojazdy > 1},		
								{"name":u"EZT2: Niesprawne wentylatory FT2","color":self.czerwony_alarm,"cond":went2_ft2 and pojazdy > 1},									
								{"name":u"EZT2: Poślizg","color":self.czerwony_alarm,"cond":state['slip_4']}
							]

							global activeMessages

							for i in range(len(messages)):
								message = messages[i]
								messageActive = message["cond"] # czy powinno byc
								messageActived = i in activeMessages # czy jest
								if messageActive and (not messageActived): # dodawanie do listy
									activeMessages.insert(0, i) # dajemy na poczatek listy, poniewaz najnowsze komunikaty pojawiaja sie na gorze
								if (not messageActive) and messageActived: # usuwanie z listy
									activeMessages.remove(i)

							# i to tyle jesli chodzi o logike, teraz rysowanie

							for i in range(len(activeMessages)):
								messageId = activeMessages[i]
								message = messages[messageId]
								draw.text((10, 414 + (i * 25)), message["name"], font = self.fontv16b, fill = message["color"])
								if i == 4: # po 4 konczymy, wiecej sie nie zmiesci
									break

							### koniec komunikatow duzych
							
							

					 #dla jednego EZT
							if (car_no == 3) or (car_no > 6):
								obrazek.paste(self.ramki1,(0,0),self.ramki1)

								#sila trakcyjna
								#sila = state['eimp_c1_fr']
								if int(state["akm"]) == 1:		
									sila1 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv1_act'] * 2.185
									pos1 = 99 - sila1
									if sila1 > 32:
										sila1 == 32
									sila2 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv2_act'] * 2.185
									pos2 = 99 - sila2	
									if sila2 > 32:
										sila2 == 32									
									draw.rectangle((126,99,137,pos1), fill=self.zolty)
									draw.rectangle((140,99,151,pos2), fill=self.zolty)								
																		
								if int(state["akm"]) == 0:
									sila1 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv1_act'] * 1.09375
									pos1 = 99 - sila1
									if sila1 > 64:
										sila1 == 64
									sila2 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv2_act'] * 1.09375
									pos2 = 99 - sila2	
									if sila2 > 64:
										sila2 == 64									
									draw.rectangle((126,99,137,pos1), fill=self.zolty)
									draw.rectangle((140,99,151,pos2), fill=self.zolty)		


								#prad czlonu
								prad = state['eimp_c1_ihv']
								pos = 101 - (prad * 0.10)-2
								draw.rectangle((575,99,588,pos), fill=self.zolty)
								self.print_fixed_with(draw, '%d' % prad, (546,180), 4, self.maly_font, self.zolty)

					#dla jednego lub dwóch
							if (3 >= pojazdy >= 1):

								draw.text((1, 286), 'EZT1', fill=self.bialy, font=self.polduzy_font2)#NR EZT
							#Pasek ikon
								if (napiecie > 2000):#Wysokie napięcie
									obrazek.paste(self.WN_on,(75,270),self.WN_on)
								else:
									obrazek.paste(self.WN_off,(75,270),self.WN_off)

								if state['main_ready']: #Gotowość WS
									obrazek.paste(self.WS_gotowosc,(150,270),self.WS_gotowosc)
								else:
									if eimp_c1_ms: #Wylacznik szybki
										obrazek.paste(self.WS_on,(150,270),self.WS_on)
									else:
										obrazek.paste(self.WS_off,(150,270),self.WS_off)

								if eimp_c1_conv:#Przetwornica
									obrazek.paste(self.przetwornica_on,(226,270),self.przetwornica_on)
								else:
									obrazek.paste(self.przetwornica_off,(226,270),self.przetwornica_off)

								if state['eimp_c1_batt']:#Bateria
									obrazek.paste(self.bateria_on,(302,270),self.bateria_on)
								else:
									obrazek.paste(self.bateria_off,(302,270),self.bateria_off)

								if eimp_c1_ms:#Falownik
									obrazek.paste(self.falownik_on,(378,270),self.falownik_on)
								else:
									obrazek.paste(self.falownik_off,(378,270),self.falownik_off)

								if (state['eimp_u1_comp_w'] & eimp_c1_conv): #Sprezarka
									obrazek.paste(self.sprezarka_on,(454,270),self.sprezarka_on)
								elif (state['eimp_u1_comp_a'] & eimp_c1_conv):
									obrazek.paste(self.sprezarka_idle,(454,270),self.sprezarka_idle)
								else:
									obrazek.paste(self.sprezarka_off,(454,270),self.sprezarka_off)

								obrazek.paste(self.M1M2_off,(530,273),self.M1M2_off)	

								if eimp_c1_ms:								
									self.aktywm1m2 += dt
									if (self.aktywm1m2<6): 										
										obrazek.paste(self.M1M2_gotow,(530,273),self.M1M2_gotow)	
									if (self.aktywm1m2>=6): 	
										if state['eimp_c1_inv1_act'] == 1:
											obrazek.paste(self.M1M2_on,(530,273),self.M1M2_on)
										if state['eimp_c1_inv1_allow'] == 0 or state['eimp_c1_inv1_error'] == 1:
											obrazek.paste(self.M1M2_awaria,(530,273),self.M1M2_awaria)		
								else:
									self.aktywm1m2 = 0	
									

								obrazek.paste(self.M3M4_off,(607,273),self.M3M4_off)									
									
								if eimp_c1_ms:								
									self.aktywm3m4 += dt
									if (self.aktywm3m4<7): 										
										obrazek.paste(self.M3M4_gotow,(607,273),self.M3M4_gotow)	
									if (self.aktywm1m2>=7): 	
										if state['eimp_c1_inv2_act'] == 1:
											obrazek.paste(self.M3M4_on,(607,273),self.M3M4_on)
										if state['eimp_c1_inv2_allow'] == 0 or state['eimp_c1_inv2_error'] == 1:
											obrazek.paste(self.M3M4_awaria,(607,273),self.M3M4_awaria)		
								else:
									self.aktywm3m4 = 0	

								#prąd silników 1,2
								im = abs(state['eimp_c1_im'])
								self.print_fixed_with(draw, '%d' % im, (695, 297), 3, self.bardzo_maly_font2, self.zolty)

								#temp silników 1,2
								#self.temp12 = self.temp12 + ((20 - temp) * 0.000329060 + (im * im / 2) * 0.000007031) * dt
								self.temp12 = self.temp12 + ((10 - self.temp12 + temp_zew) * 0.000319 + (im * im * 2.5) * 0.000000691) * dt - 0.0000230 * temp_zew * dt								
								self.print_fixed_with(draw, '%i' % self.temp12, (695, 317), 3, self.bardzo_maly_font2, self.zolty)

								#prąd silników 3,4
								self.print_fixed_with(draw, '%d' % im, (757, 297), 3, self.bardzo_maly_font2, self.zolty)

								#temp silników 3,4
								#self.temp34 = self.temp34 + ((15 - temp) * 0.000319000 + (im * im / 2) * 0.000006991) * dt
								self.temp34 = self.temp34 + ((10 - self.temp34 + temp_zew) * 0.000319 + (im * im * 2.5) * 0.000000691) * dt - 0.0000230 * temp_zew * dt											
								self.print_fixed_with(draw, '%i' % self.temp34, (757, 317), 3, self.bardzo_maly_font2, self.zolty)

							#Ikona EZT
								obrazek.paste(self.ezt,(5, 218),self.ezt)
								draw.text((14,238), '1', fill=self.bialy, font=self.bardzo_maly_font)
								#Drzwi EZT1
								#człon a
								x=58
								if doors_ezt1: #wszystkie człony mają pokazywać razem, gdy cokolwiek otwarte
									kolor = self.czerwony
									dx=10
								else:
									kolor = self.niebieski
									dx=0
								draw.line([(x-dx,225),(x-15-dx,225),(x-15-dx,250),(x-dx,250),(x-dx,225)], fill=kolor, width=2)
								draw.line([(x-3-dx,228),(x-11-dx,228),(x-11-dx,239),(x-3-dx,239),(x-3-dx,228)], fill=kolor, width=2)
								draw.line([(x+15+dx,225),(x+dx,225),(x+dx,250),(x+15+dx,250),(x+15+dx,225)], fill=kolor, width=2)
								draw.line([(x+11+dx,228),(x+3+dx,228),(x+3+dx,239),(x+11+dx,239),(x+11+dx,228)], fill=kolor, width=2)
								#człon s
								x=136
								draw.line([(x-dx,225),(x-15-dx,225),(x-15-dx,250),(x-dx,250),(x-dx,225)], fill=kolor, width=2)
								draw.line([(x-3-dx,228),(x-11-dx,228),(x-11-dx,239),(x-3-dx,239),(x-3-dx,228)], fill=kolor, width=2)
								draw.line([(x+15+dx,225),(x+dx,225),(x+dx,250),(x+15+dx,250),(x+15+dx,225)], fill=kolor, width=2)
								draw.line([(x+11+dx,228),(x+3+dx,228),(x+3+dx,239),(x+11+dx,239),(x+11+dx,228)], fill=kolor, width=2)
								#człon b
								x=214
								draw.line([(x-dx,225),(x-15-dx,225),(x-15-dx,250),(x-dx,250),(x-dx,225)], fill=kolor, width=2)
								draw.line([(x-3-dx,228),(x-11-dx,228),(x-11-dx,239),(x-3-dx,239),(x-3-dx,228)], fill=kolor, width=2)
								draw.line([(x+15+dx,225),(x+dx,225),(x+dx,250),(x+15+dx,250),(x+15+dx,225)], fill=kolor, width=2)
								draw.line([(x+11+dx,228),(x+3+dx,228),(x+3+dx,239),(x+11+dx,239),(x+11+dx,228)], fill=kolor, width=2)

								#oświeltenie przedziałów
								if state['lights_compartments'] == 1:
									kolor=self.zolty
								else:
									kolor=self.szary
								draw.line([(31,222),(83,222)], fill=kolor, width=3)
								draw.line([(109,222),(163,222)], fill=kolor, width=3)
								draw.line([(187,222),(241,222)], fill=kolor, width=3)

								#pantografy
								if ((eimp_u1_pf & (cab == 1)) | (eimp_u1_pr & (cab == -1))): #przedni
									draw.line([(115,220),(107,213),(115,206),(122,213),(115,220)], fill=self.zolty, width=2)
									draw.line([(115,220),(115,206)], fill=self.zolty, width=2)
								else:
									draw.line([(115,220),(107,216),(115,214),(122,216),(115,220)], fill=self.niebieski, width=2)
									draw.line([(115,220),(115,214)], fill=self.niebieski, width=2)

								if ((eimp_u1_pf & (cab == -1)) | (eimp_u1_pr & (cab == 1))): #tylny
									draw.line([(155,220),(147,213),(155,206),(162,213),(155,220)], fill=self.zolty, width=2)
									draw.line([(155,220),(155,206)], fill=self.zolty, width=2)
								else:
									draw.line([(155,220),(147,216),(155,214),(162,216),(155,220)], fill=self.niebieski, width=2)
									draw.line([(155,220),(155,214)], fill=self.niebieski, width=2)

					#dla dwóch EZT
							if (pojazdy == 2):
								obrazek.paste(self.ramki2,(0,0), self.ramki2)
								draw.text((1, 356), 'EZT2', fill=self.bialy, font=self.polduzy_font2)#NR EZT

								
								
								#sila trakcyjna
						#		sila = state['eimp_c1_fr']
						#		if int(state["akm"]) == 0:										
						#			pos = 100 - (sila * 0.5)-2
						#		if int(state["akm"]) == 1:		
						#			pos = 100 - (sila * 1)-2									
						#		draw.rectangle((126,99,137,pos), fill=self.zolty)
						#		draw.rectangle((139,99,150,pos), fill=self.zolty)
						#		sila = state['eimp_c2_fr']
						#		if int(state["akm"]) == 0:										
						#			pos = 100 - (sila * 0.5)-2
						#		if int(state["akm"]) == 1:		
						##			pos = 100 - (sila * 1)-2	
							#	draw.rectangle((152,99,163,pos), fill=self.zolty)
						#		draw.rectangle((165,99,177,pos), fill=self.zolty)
								
								
								if int(state["akm"]) == 1:		
									sila1 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv1_act'] * 2.185
									pos1 = 99 - sila1
									if sila1 > 32:
										sila1 == 32
									sila2 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv2_act'] * 2.185
									pos2 = 99 - sila2	
									if sila2 > 32:
										sila2 == 32									
									draw.rectangle((126,99,137,pos1), fill=self.zolty)
									draw.rectangle((139,99,150,pos2), fill=self.zolty)	
									
									sila3 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c2_pr'] * state['eimp_c2_inv1_act'] * 2.185
									pos3 = 99 - sila3
									if sila3 > 32:
										sila3 == 32
									sila4 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c2_pr'] * state['eimp_c2_inv2_act'] * 2.185
									pos4 = 99 - sila4	
									if sila4 > 32:
										sila4 == 32									
									draw.rectangle((152,99,163,pos3), fill=self.zolty)
									draw.rectangle((165,99,177,pos4), fill=self.zolty)
									
								if int(state["akm"]) == 0:
									sila1 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv1_act'] * 1.09375
									pos1 = 99 - sila1
									if sila1 > 64:
										sila1 == 64
									sila2 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c1_pr'] * state['eimp_c1_inv2_act'] * 1.09375
									pos2 = 99 - sila2	
									if sila2 > 64:
										sila2 == 64									
									draw.rectangle((126,99,137,pos1), fill=self.zolty)
									draw.rectangle((140,99,151,pos2), fill=self.zolty)		
									
									sila3 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c2_pr'] * state['eimp_c2_inv1_act'] * 1.09375
									pos3 = 99 - sila3
									if sila3 > 64:
										sila3 == 64
									sila4 = ( 1+min( 36, 1800/( speed+0.1) ) ) * state['eimp_c2_pr'] * state['eimp_c2_inv2_act'] * 1.09375
									pos4 = 99 - sila4	
									if sila4 > 64:
										sila4 == 64									
									draw.rectangle((152,99,163,pos3), fill=self.zolty)
									draw.rectangle((165,99,177,pos4), fill=self.zolty)										

								#prad czlonu
								prad = state['eimp_c1_ihv']
								pos = 101 - (prad * 0.10)-2
								draw.rectangle((575,99,587,pos), fill=self.zolty)
								self.print_fixed_with(draw, '%d' % prad, (539,195), 4, self.maly_font, self.zolty)
								prad = state['eimp_c2_ihv']
								pos = 101 - (prad * 0.10)-2
								draw.rectangle((589,99,601,pos), fill=self.zolty)
								self.print_fixed_with(draw, '%d' % prad, (574,195), 4, self.maly_font, self.zolty)

							#Pasek ikon
								if (napiecie > 2000):#Wysokie napięcie
									obrazek.paste(self.WN_on,(75,339),self.WN_on)
								else:
									obrazek.paste(self.WN_off,(75,339),self.WN_off)

								if state['main_ready']: #Gotowość WS
									obrazek.paste(self.WS_gotowosc,(150,339),self.WS_gotowosc)
								else:
									if eimp_c2_ms: #Wylacznik szybki
										obrazek.paste(self.WS_on,(150,339),self.WS_on)
									else:
										obrazek.paste(self.WS_off,(150,339),self.WS_off)	

								if eimp_c2_conv:#Przetwornica
									obrazek.paste(self.przetwornica_on,(226,339),self.przetwornica_on)
								else:
									obrazek.paste(self.przetwornica_off,(226,339),self.przetwornica_off)

								if state['eimp_c2_batt']:#Bateria
									obrazek.paste(self.bateria_on,(302,339),self.bateria_on)
								else:
									obrazek.paste(self.bateria_off,(302,339),self.bateria_off)

								if eimp_c2_ms:#Falownik
									obrazek.paste(self.falownik_on,(378,339),self.falownik_on)
								else:
									obrazek.paste(self.falownik_off,(378,339),self.falownik_off)

								if (state['eimp_u2_comp_w'] & eimp_c2_conv): #Sprezarka
									obrazek.paste(self.sprezarka_on,(454,339),self.sprezarka_on)
								elif (state['eimp_u2_comp_a'] & eimp_c2_conv):
									obrazek.paste(self.sprezarka_idle,(454,339),self.sprezarka_idle)
								else:
									obrazek.paste(self.sprezarka_off,(454,339),self.sprezarka_off)

								obrazek.paste(self.M1M2_off,(530,339),self.M1M2_off)	

								if eimp_c2_ms:								
									self.aktyw2m1m2 += dt
									if (self.aktyw2m1m2<6): 										
										obrazek.paste(self.M1M2_gotow,(530,339),self.M1M2_gotow)	
									if (self.aktyw2m1m2>=6): 	
										if state['eimp_c2_inv1_act'] == 1:
											obrazek.paste(self.M1M2_on,(530,339),self.M1M2_on)
										if state['eimp_c2_inv1_allow'] == 0 or state['eimp_c2_inv1_error'] == 1:
											obrazek.paste(self.M1M2_awaria,(530,339),self.M1M2_awaria)		
								else:
									self.aktyw2m1m2 = 0	
									

								obrazek.paste(self.M3M4_off,(607,339),self.M3M4_off)									
									
								if eimp_c2_ms:								
									self.aktyw2m3m4 += dt
									if (self.aktyw2m3m4<7): 										
										obrazek.paste(self.M3M4_gotow,(607,339),self.M3M4_gotow)	
									if (self.aktyw2m3m4>=7): 	
										if state['eimp_c2_inv2_act'] == 1:
											obrazek.paste(self.M3M4_on,(607,339),self.M3M4_on)
										if state['eimp_c2_inv2_allow'] == 0 or state['eimp_c2_inv2_error'] == 1:
											obrazek.paste(self.M3M4_awaria,(607,339),self.M3M4_awaria)		
								else:
									self.aktyw2m3m4 = 0		


								#prąd silników 1,2
								im = abs(state['eimp_c2_im'])
								self.print_fixed_with(draw, '%d' % im, (695, 365), 3, self.bardzo_maly_font2, self.zolty)
								#temp silników 1,2
								#self.temp56 = self.temp56 + ((20 - temp) * 0.000329030 + (im * im / 2) * 0.000007) * dt
								self.temp56 = self.temp56 + ((10 - self.temp56 + temp_zew) * 0.000319 + (im * im * 2.5) * 0.000000691) * dt - 0.0000230 * temp_zew * dt										
								self.print_fixed_with(draw, '%i' % self.temp56, (695, 385), 3, self.bardzo_maly_font2, self.zolty)

								#prąd silników 3,4
								self.print_fixed_with(draw, '%d' % im, (757, 365), 3, self.bardzo_maly_font2, self.zolty)

								#temp silników 3,4
								#self.temp78 = self.temp78 + ((20 - temp) * 0.000389000 + (im * im / 2) * 0.000008091) * dt
								self.temp78 = self.temp78 + ((10 - self.temp78 + temp_zew) * 0.000319 + (im * im * 2.5) * 0.000000691) * dt - 0.0000230 * temp_zew * dt									
								self.print_fixed_with(draw, '%i' % self.temp78, (757, 385), 3, self.bardzo_maly_font2, self.zolty)

							#Ikona EZT
								obrazek.paste(self.ezt,(269, 218),self.ezt)
								draw.text((278,238), '2', fill=self.bialy, font=self.bardzo_maly_font)
								#Drzwi EZT1
								#człon a
								x=322
								if doors_ezt2:
									kolor = self.czerwony
									dx=10
								else:
									kolor = self.niebieski
									dx=0
								draw.line([(x-dx,225),(x-15-dx,225),(x-15-dx,250),(x-dx,250),(x-dx,225)], fill=kolor, width=2)
								draw.line([(x-3-dx,228),(x-11-dx,228),(x-11-dx,239),(x-3-dx,239),(x-3-dx,228)], fill=kolor, width=2)
								draw.line([(x+15+dx,225),(x+dx,225),(x+dx,250),(x+15+dx,250),(x+15+dx,225)], fill=kolor, width=2)
								draw.line([(x+11+dx,228),(x+3+dx,228),(x+3+dx,239),(x+11+dx,239),(x+11+dx,228)], fill=kolor, width=2)
								#człon s
								x=400
								draw.line([(x-dx,225),(x-15-dx,225),(x-15-dx,250),(x-dx,250),(x-dx,225)], fill=kolor, width=2)
								draw.line([(x-3-dx,228),(x-11-dx,228),(x-11-dx,239),(x-3-dx,239),(x-3-dx,228)], fill=kolor, width=2)
								draw.line([(x+15+dx,225),(x+dx,225),(x+dx,250),(x+15+dx,250),(x+15+dx,225)], fill=kolor, width=2)
								draw.line([(x+11+dx,228),(x+3+dx,228),(x+3+dx,239),(x+11+dx,239),(x+11+dx,228)], fill=kolor, width=2)
								#człon b
								x=478
								draw.line([(x-dx,225),(x-15-dx,225),(x-15-dx,250),(x-dx,250),(x-dx,225)], fill=kolor, width=2)
								draw.line([(x-3-dx,228),(x-11-dx,228),(x-11-dx,239),(x-3-dx,239),(x-3-dx,228)], fill=kolor, width=2)
								draw.line([(x+15+dx,225),(x+dx,225),(x+dx,250),(x+15+dx,250),(x+15+dx,225)], fill=kolor, width=2)
								draw.line([(x+11+dx,228),(x+3+dx,228),(x+3+dx,239),(x+11+dx,239),(x+11+dx,228)], fill=kolor, width=2)

								#oświeltenie przedziałów
								x=264
								if state['lights_compartments'] == 1:
									kolor=self.zolty
								else:
									kolor=self.szary
								draw.line([(x+31,222),(x+83,222)], fill=kolor, width=3)
								draw.line([(x+109,222),(x+163,222)], fill=kolor, width=3)
								draw.line([(x+187,222),(x+241,222)], fill=kolor, width=3)

								#pantografy
								if ((eimp_u2_pf & (cab == 1)) | (eimp_u2_pr & (cab == -1))):
									draw.line([(x+115,220),(x+107,213),(x+115,206),(x+122,213),(x+115,220)], fill=self.zolty, width=2)
									draw.line([(x+115,220),(x+115,206)], fill=self.zolty, width=2)
								else:
									draw.line([(x+115,220),(x+107,216),(x+115,214),(x+122,216),(x+115,220)], fill=self.niebieski, width=2)
									draw.line([(x+115,220),(x+115,214)], fill=self.niebieski, width=2)

								if ((eimp_u2_pf & (cab == -1)) | (eimp_u2_pr & (cab == 1))):
									draw.line([(x+155,220),(x+147,213),(x+155,206),(x+162,213),(x+155,220)], fill=self.zolty, width=2)
									draw.line([(x+155,220),(x+155,206)], fill=self.zolty, width=2)
								else:
									draw.line([(x+155,220),(x+147,216),(x+155,214),(x+162,216),(x+155,220)], fill=self.niebieski, width=2)
									draw.line([(x+155,220),(x+155,214)], fill=self.niebieski, width=2)

						if (self.aktyw>=21) and (self.tryb == 2):
							obrazek.paste(self.podklad_alarm, (0, 0), self.podklad_alarm)	

							# i to tyle jesli chodzi o logike, teraz rysowanie

							for i in range(len(activeMessages)):
								messageId = activeMessages[i]
								message = messages[messageId]
								if int(state["akm"]) == 1:
									self.print_left(draw, message["name"], 56, 265 + i * 20, self.maly_font2, self.bialy)
									draw.rectangle((43,261 + i * 20,52,269 + i * 20), self.czerwony)	
								else: 
									self.print_left(draw, message["name"], 56, 222 + i * 20, self.maly_font2, self.bialy)
									draw.rectangle((43,218 + i * 20,52,222 + i * 20), self.czerwony)										
								if i == 13: # po 4 konczymy, wiecej sie nie zmiesci
									break								
								
						if (self.aktyw>=21) and (self.tryb == 6):
							obrazek.paste(self.podklad_hamulec, (0, 0))		


							#cylindry					
							#obroty wskazówek w radianach
							Ra1 = radians((state['eimp_pn1_bc']*36 - 107.62))
							srodek = (92, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra1)), srodek[1]-(r_s*cos(Ra1)))
							p_s = (srodek[0]+(1*(-sin(Ra1))), srodek[1]-(1*(-cos(Ra1))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zielonastrzalka, width=4)	

							self.print_center(draw, str('%.0f' % (state['eimp_pn1_bc'] * 100) ), 61,135, self.bardzo_maly_font2, self.zielonastrzalka)															
							Ra2 = radians((state['eimp_pn2_bc']*36 - 107.62))
							srodek = (92, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra2)), srodek[1]-(r_s*cos(Ra2)))
							p_s = (srodek[0]+(1*(-sin(Ra2))), srodek[1]-(1*(-cos(Ra2))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.niebieskastrzalka, width=4)				
							self.print_center(draw, str('%.0f' % (state['eimp_pn3_bc'] * 100) ), 93,135, self.bardzo_maly_font2, self.niebieskastrzalka)					
							Ra3 = radians((state['eimp_pn3_bc']*36 - 107.62))
							srodek = (92, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra3)), srodek[1]-(r_s*cos(Ra3)))
							p_s = (srodek[0]+(1*(-sin(Ra3))), srodek[1]-(1*(-cos(Ra3))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zoltastrzalka, width=4)		
							self.print_center(draw, str('%.0f' % (state['eimp_pn2_bc'] * 100) ), 124,135, self.bardzo_maly_font2, self.zoltastrzalka)							

							#zasilanie					
							#obroty wskazówek w radianach
							Ra1 = radians((state['eimp_pn1_sp']*21.8 - 109.5))
							srodek = (92+399, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra1)), srodek[1]-(r_s*cos(Ra1)))
							p_s = (srodek[0]+(1*(-sin(Ra1))), srodek[1]-(1*(-cos(Ra1))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zielonastrzalka, width=4)				
							self.print_center(draw, str('%.0f' % (state['eimp_pn1_sp'] * 100) ), 61+399,135, self.bardzo_maly_font2, self.zielonastrzalka)				

							Ra2 = radians((state['eimp_pn2_sp']*21.8 - 109.5))
							srodek = (92+399, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra2)), srodek[1]-(r_s*cos(Ra2)))
							p_s = (srodek[0]+(1*(-sin(Ra2))), srodek[1]-(1*(-cos(Ra2))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.niebieskastrzalka, width=4)	
							draw.ellipse([(75+399, 76), (110, 112)], fill=self.szary2)				
							self.print_center(draw, str('%.0f' % (state['eimp_pn3_sp'] * 100) ), 93+399,135, self.bardzo_maly_font2, self.niebieskastrzalka)					
							Ra3 = radians((state['eimp_pn3_sp']*21.8 - 109.5))
							srodek = (92+399, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra3)), srodek[1]-(r_s*cos(Ra3)))
							p_s = (srodek[0]+(1*(-sin(Ra3))), srodek[1]-(1*(-cos(Ra3))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zoltastrzalka, width=4)			
							self.print_center(draw, str('%.0f' % (state['eimp_pn2_sp'] * 100) ), 124+399,135, self.bardzo_maly_font2, self.zoltastrzalka)	





							#obciazenie								

							obcra = ((state['eimp_pn1_mass']) - 13.548) * 7.36			
							obcra2 = round(0.2 * obcra) * 5
							obcra3 = str('%.0f' % obcra2)								

							#obroty wskazówek w radianach
							obc_ra = radians((obcra2*0.36 - 107.62))
							srodek = (92+199, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(obc_ra)), srodek[1]-(r_s*cos(obc_ra)))
							p_s = (srodek[0]+(1*(-sin(obc_ra))), srodek[1]-(1*(-cos(obc_ra))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zielonastrzalka, width=4)		
							self.print_center(draw, obcra3, 61+199,135, self.bardzo_maly_font2, self.zielonastrzalka)			


							obcs = ((state['eimp_pn3_mass']) - 13.548) * 7.36	
							obcs2 = round(0.2 * obcs) * 5
							obcs3 = str('%.0f' % obcs2)								

							#obroty wskazówek w radianach
							obc_s = radians((obcs2*0.36 - 107.62))
							srodek = (92+199, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(obc_s)), srodek[1]-(r_s*cos(obc_s)))
							p_s = (srodek[0]+(1*(-sin(obc_s))), srodek[1]-(1*(-cos(obc_s))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.niebieskastrzalka, width=4)		
							self.print_center(draw, obcs3, 93+199,135, self.bardzo_maly_font2, self.niebieskastrzalka)										

							obcrb =  ((state['eimp_pn2_mass']) - 20.122) * 5.69						
							obcrb2 = round(0.2 * obcrb) * 5
							obcrb3 = str('%.0f' % obcrb2)								

							#obroty wskazówek w radianach
							obc_rb = radians((obcrb2*0.36 - 107.62))
							srodek = (92+199, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(obc_rb)), srodek[1]-(r_s*cos(obc_rb)))
							p_s = (srodek[0]+(1*(-sin(obc_rb))), srodek[1]-(1*(-cos(obc_rb))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zoltastrzalka, width=4)		
							self.print_center(draw, obcrb3, 124+199,135, self.bardzo_maly_font2, self.zoltastrzalka)			
							draw.ellipse([(75+199, 76), (110+199, 112)], fill=self.szary2)					


							#sprezynka				
							#obroty wskazówek w radianach
							Ra1 = radians((state['eimp_pn1_spring']*21.8 - 109.5))
							srodek = (92+598, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra1)), srodek[1]-(r_s*cos(Ra1)))
							p_s = (srodek[0]+(1*(-sin(Ra1))), srodek[1]-(1*(-cos(Ra1))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zielonastrzalka, width=4)				
							self.print_center(draw, str('%.0f' % (state['eimp_pn1_spring'] * 100) ), 61+599,135, self.bardzo_maly_font2, self.zielonastrzalka)				


							Ra3 = radians((state['eimp_pn3_spring']*21.8 - 109.5))
							srodek = (92+598, 94)
							#długości wskazówek
							r_s = 82
							#punkty końcowe
							k_s = (srodek[0]+(r_s*sin(Ra3)), srodek[1]-(r_s*cos(Ra3)))
							p_s = (srodek[0]+(1*(-sin(Ra3))), srodek[1]-(1*(-cos(Ra3))))
							#rysowanie wskazówek
							draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.zoltastrzalka, width=4)			
							self.print_center(draw, str('%.0f' % (state['eimp_pn3_spring'] * 100) ), 93+599,135, self.bardzo_maly_font2, self.niebieskastrzalka)			
							draw.ellipse([(75+598, 76), (110+598, 112)], fill=self.szary2)	



							#ciezarki
							self.print_right(draw, str('%.1f' % (state['eimp_pn1_mass']) ), 150,265, self.maly_font2, self.zolty)					
							self.print_right(draw, str('%.1f' % (state['eimp_pn2_mass']) ), 412,265, self.maly_font2, self.zolty)								
							self.print_right(draw, str('%.1f' % (state['eimp_pn3_mass']) ), 675,265, self.maly_font2, self.zolty)								
							# siła zadana	
							silka_float = ( 1+min( 36, 1800/( speed+0.1 ) ) ) * min (state['eimp_t_pdb'] / 0.7, min (speed * 0.06, 1) )
							if silka_float < 0:
								silka == silka_float * -1								
							silka = str('%.0f' % silka_float)

							#Fzad
							#S
							self.print_right(draw, silka, 412,217, self.maly_font2, self.zolty)											
							self.print_right(draw, silka, 412,241, self.maly_font2, self.zolty)					

							#Ra
							self.print_right(draw, silka, 150,217, self.maly_font2, self.zolty)													
							self.print_right(draw, silka, 150,241, self.maly_font2, self.zolty)					
							#Rb
							self.print_right(draw, silka, 675,217, self.maly_font2, self.zolty)										
							self.print_right(draw, silka, 675,241, self.maly_font2, self.zolty)					
							#% zad
							self.print_right(draw, str('%.0f' % (state['eimp_t_pdb'] * 100)), 150,290, self.maly_font2, self.zolty)					
							self.print_right(draw, str('%.0f' % (state['eimp_t_pdb'] * 100)), 412,290, self.maly_font2, self.zolty)					
							self.print_right(draw, str('%.0f' % (state['eimp_t_pdb'] * 100)), 675,290, self.maly_font2, self.zolty)					

							draw.ellipse([(75+399, 76), (110+399, 112)], fill=self.szary2)		
							draw.ellipse([(75, 76), (110, 112)], fill=self.szary2)								

						#RA
							
																
							#czujniki OK	
							draw.rectangle((17,348,30,361), self.zielony)						
							draw.rectangle((17,367,30,381), self.zielony)	
							draw.rectangle((17,386,30,399), self.zielony)								
							draw.rectangle((17,405,30,418), self.zielony)	
							draw.rectangle((17,424,30,437), self.zielony)								
							#PN 
							if (indir_brake):
								draw.rectangle((17,461,30,475), self.zielony)	
							#BCU
							draw.rectangle((17,481,30,493), self.zielony)	

							#grzyb
							if (state['emergency_brake']) == 1:
								draw.rectangle((17+111,310,30+111,323), self.zielony)										

							#sprezyna
							if (brakes_1_spring_active == 0):
								draw.rectangle((17+111,367,30+111,381), self.zielony)	
							#start	
							if (dir_brake):
								draw.rectangle((17+111,424,30+111,437), self.zielony)

				#S
							#ED	
							if state['eimp_c1_inv1_act'] == 0 or state['epfuse'] == 0 or ((state['brake_op_mode_flag']) < 8):
								draw.rectangle((17+263,310,30+263,323), self.zielony)	
							if state['eimp_c1_inv2_act'] == 0 or state['epfuse'] == 0 or ((state['brake_op_mode_flag']) < 8):				
								draw.rectangle((17+263,329,30+263,342), self.zielony)							
			
																
							#czujniki OK	
							draw.rectangle((17+263,348,30+263,361), self.zielony)						
							draw.rectangle((17+263,367,30+263,381), self.zielony)	
							draw.rectangle((17+263,386,30+263,399), self.zielony)								
							draw.rectangle((17+263,405,30+263,418), self.zielony)	
							draw.rectangle((17+263,424,30+263,437), self.zielony)								
							#PN 
							if (indir_brake):
								draw.rectangle((17+263,461,30+263,475), self.zielony)	
							#BCU
							draw.rectangle((17+263,481,30+263,493), self.zielony)	

							#grzyb
							if (state['emergency_brake']) == 1:
								draw.rectangle((17+263+111,310,30+263+111,323), self.zielony)										

							#start	
							if (dir_brake):
								draw.rectangle((17+263+111,424,30+263+111,437), self.zielony)

			#RB															
			
																
							#czujniki OK	
							draw.rectangle((17+526,348,30+526,361), self.zielony)						
							draw.rectangle((17+526,367,30+526,381), self.zielony)	
							draw.rectangle((17+526,386,30+526,399), self.zielony)								
							draw.rectangle((17+526,405,30+526,418), self.zielony)	
							draw.rectangle((17+526,424,30+526,437), self.zielony)								
							#PN 
							if (indir_brake):
								draw.rectangle((17+526,461,30+526,475), self.zielony)	
							#BCU
							draw.rectangle((17+526,481,30+526,493), self.zielony)	

							#grzyb
							if (state['emergency_brake']) == 1:
								draw.rectangle((17+526+111,310,30+526+111,323), self.zielony)										

							#sprezyna
							if (brakes_3_spring_active == 0):
								draw.rectangle((17+526+111,367,30+526+111,381), self.zielony)	
							#start	
							if (dir_brake):
								draw.rectangle((17+526+111,424,30+526+111,437), self.zielony)								
						if (self.aktyw>=21) and (self.tryb == 4):	
							obrazek.paste(self.podklad_drzwi, (0, 0))	
							cab = state['cab']
							if cab == 1:
								drzwi_ra_p = state['doors_r_1']
								drzwi_rb_p = state['doors_r_3']
								drzwi_ra_l = state['doors_l_1']
								drzwi_rb_l = state['doors_l_3']									
							if cab == -1:
								drzwi_ra_p = state['doors_r_3']					
								drzwi_rb_p = state['doors_r_1']
								drzwi_ra_l = state['doors_l_3']					
								drzwi_rb_l = state['doors_l_1']								
								
							if drzwi_ra_p:
								draw.rectangle((174,83,213,93), fill=self.czerwony)	
								draw.rectangle((189,83,199,93), fill=self.szary2)									
								draw.rectangle((174+64,83,213+64,93), fill=self.czerwony)	
								draw.rectangle((189+64,83,199+64,93), fill=self.szary2)										
							else:
								draw.rectangle((180,83,207,93), fill=self.zielony)								
								draw.rectangle((180+64,83,207+64,93), fill=self.zielony)	
								
							if state['doors_r_2']:
								draw.rectangle((174+185,83,213+185,93), fill=self.czerwony)	
								draw.rectangle((189+185,83,199+185,93), fill=self.szary2)									
								draw.rectangle((174+89+185,83,213+89+185,93), fill=self.czerwony)	
								draw.rectangle((189+89+185,83,199+89+185,93), fill=self.szary2)										
							else:
								draw.rectangle((180+185,83,207+185,93), fill=self.zielony)								
								draw.rectangle((180+89+185,83,207+89+185,93), fill=self.zielony)
								
							if drzwi_rb_p:
								draw.rectangle((174+394,83,213+394,93), fill=self.czerwony)	
								draw.rectangle((189+394,83,199+394,93), fill=self.szary2)									
								draw.rectangle((174+64+394,83,213+64+394,93), fill=self.czerwony)	
								draw.rectangle((189+64+394,83,199+64+394,93), fill=self.szary2)										
							else:
								draw.rectangle((180+394,83,207+394,93), fill=self.zielony)								
								draw.rectangle((180+64+394,83,207+64+394,93), fill=self.zielony)	
								
								
							if drzwi_ra_l:
								draw.rectangle((174,83+107,213,93+107), fill=self.czerwony)	
								draw.rectangle((189,83+107,199,93+107), fill=self.szary2)									
								draw.rectangle((174+64,83+107,213+64,93+107), fill=self.czerwony)	
								draw.rectangle((189+64,83+107,199+64,93+107), fill=self.szary2)										
							else:
								draw.rectangle((180,83+107,207,93+107), fill=self.zielony)								
								draw.rectangle((180+64,83+107,207+64,93+107), fill=self.zielony)	
								
							if state['doors_l_2']:
								draw.rectangle((174+185,83+107,213+185,93+107), fill=self.czerwony)	
								draw.rectangle((189+185,83+107,199+185,93+107), fill=self.szary2)									
								draw.rectangle((174+89+185,83+107,213+89+185,93+107), fill=self.czerwony)	
								draw.rectangle((189+89+185,83+107,199+89+185,93+107), fill=self.szary2)										
							else:
								draw.rectangle((180+185,83+107,207+185,93+107), fill=self.zielony)								
								draw.rectangle((180+89+185,83+107,207+89+185,93+107), fill=self.zielony)
								
							if drzwi_rb_l:
								draw.rectangle((174+394,83+107,213+394,93+107), fill=self.czerwony)	
								draw.rectangle((189+394,83+107,199+394,93+107), fill=self.szary2)									
								draw.rectangle((174+64+394,83+107,213+64+394,93+107), fill=self.czerwony)	
								draw.rectangle((189+64+394,83+107,199+64+394,93+107), fill=self.szary2)										
							else:
								draw.rectangle((180+394,83+107,207+394,93+107), fill=self.zielony)								
								draw.rectangle((180+64+394,83+107,207+64+394,93+107), fill=self.zielony)	
							if sprawnosc_drzwi_wylosowana: 
								obrazek.paste(self.drzwi_blad_can, (370, 467))									
								
							if (pojazdy == 2):
								

								obrazek.paste(self.podklad_drzwi_ezt2, (0, 263))	
								cab = state['cab']
								if cab == 1:
									drzwi_ra2_p = state['doors_r_4']
									drzwi_rb2_p = state['doors_r_6']
									drzwi_ra2_l = state['doors_l_4']
									drzwi_rb2_l = state['doors_l_3']									
								if cab == -1:
									drzwi_ra2_p = state['doors_r_6']					
									drzwi_rb2_p = state['doors_r_4']
									drzwi_ra2_l = state['doors_l_3']					
									drzwi_rb2_l = state['doors_l_4']								

								if drzwi_ra2_p:
									draw.rectangle((174,83+252,213,93+252), fill=self.czerwony)	
									draw.rectangle((189,83+252,199,93+252), fill=self.szary2)									
									draw.rectangle((174+64,83+252,213+64,93+252), fill=self.czerwony)	
									draw.rectangle((189+64,83+252,199+64,93+252), fill=self.szary2)										
								else:
									draw.rectangle((180,83+252,207,93+252), fill=self.zielony)								
									draw.rectangle((180+64,83+252,207+64,93+252), fill=self.zielony)	

								if state['doors_r_5']:
									draw.rectangle((174+185,83+252,213+185,93+252), fill=self.czerwony)	
									draw.rectangle((189+185,83+252,199+185,93+252), fill=self.szary2)									
									draw.rectangle((174+89+185,83+252,213+89+185,93+252), fill=self.czerwony)	
									draw.rectangle((189+89+185,83+252,199+89+185,93+252), fill=self.szary2)										
								else:
									draw.rectangle((180+185,83+252,207+185,93+252), fill=self.zielony)								
									draw.rectangle((180+89+185,83+252,207+89+185,93+252), fill=self.zielony)

								if drzwi_rb2_p:
									draw.rectangle((174+394,83+252,213+394,93+252), fill=self.czerwony)	
									draw.rectangle((189+394,83+252,199+394,93+252), fill=self.szary2)									
									draw.rectangle((174+64+394,83+252,213+64+394,93+252), fill=self.czerwony)	
									draw.rectangle((189+64+394,83+252,199+64+394,93+252), fill=self.szary2)										
								else:
									draw.rectangle((180+394,83+252,207+394,93+252), fill=self.zielony)								
									draw.rectangle((180+64+394,83+252,207+64+394,93+252), fill=self.zielony)	


								if drzwi_ra2_l:
									draw.rectangle((174,83+252+107,213,93+252+107), fill=self.czerwony)	
									draw.rectangle((189,83+252+107,199,93+252+107), fill=self.szary2)									
									draw.rectangle((174+64,83+252+107,213+64,93+252+107), fill=self.czerwony)	
									draw.rectangle((189+64,83+252+107,199+64,93+252+107), fill=self.szary2)										
								else:
									draw.rectangle((180,83+252+107,207,93+252+107), fill=self.zielony)								
									draw.rectangle((180+64,83+252+107,207+64,93+252+107), fill=self.zielony)	

								if state['doors_l_5']:
									draw.rectangle((174+185,83+252+107,213+185,93+252+107), fill=self.czerwony)	
									draw.rectangle((189+185,83+252+107,199+185,93+252+107), fill=self.szary2)									
									draw.rectangle((174+89+185,83+252+107,213+89+185,93+252+107), fill=self.czerwony)	
									draw.rectangle((189+89+185,83+252+107,199+89+185,93+252+107), fill=self.szary2)										
								else:
									draw.rectangle((180+185,83+252+107,207+185,93+252+107), fill=self.zielony)								
									draw.rectangle((180+89+185,83+252+107,207+89+185,93+252+107), fill=self.zielony)

								if drzwi_rb2_l:
									draw.rectangle((174+394,83+252+107,213+394,93+252+107), fill=self.czerwony)	
									draw.rectangle((189+394,83+252+107,199+394,93+252+107), fill=self.szary2)									
									draw.rectangle((174+64+394,83+252+107,213+64+394,93+252+107), fill=self.czerwony)	
									draw.rectangle((189+64+394,83+252+107,199+64+394,93+252+107), fill=self.szary2)										
								else:
									draw.rectangle((180+394,83+252+107,207+394,93+252+107), fill=self.zielony)								
									draw.rectangle((180+64+394,83+252+107,207+64+394,93+252+107), fill=self.zielony)								

						if (self.aktyw>=21) and (self.tryb == 5):
							obrazek.paste(self.reflektory, (0, 0))	
							if (lights_front & 1): # lewe
								draw.ellipse((64, 162, 114, 211), fill = self.bialy)
							if (lights_front & 2): # lewe czerwone
								draw.ellipse((251, 162, 301, 211), fill = self.czerwony)
							if (lights_front & 4): # gorne
								draw.ellipse((373, 61, 423, 110), fill = self.bialy)
							if (lights_front & 16): # prawe
								draw.ellipse((688, 162, 737, 211), fill = self.bialy)							
							if (lights_front & 32): # prawe czerwone
								draw.ellipse((502, 162, 550, 211), fill = self.czerwony)		
								
							if (lights_rear & 16): # lewe
								draw.ellipse((64, 162+252, 114, 211+252), fill = self.bialy)
							if (lights_rear & 32): # lewe czerwone
								draw.ellipse((251, 162+252, 301, 211+252), fill = self.czerwony)
							if (lights_rear & 4): # gorne
								draw.ellipse((373, 61+252, 423, 110+252), fill = self.bialy)
							if (lights_rear & 1): # prawe
								draw.ellipse((688, 162+252, 737, 211+252), fill = self.bialy)							
							if (lights_rear & 2): # prawe czerwone
								draw.ellipse((502, 162+252, 550, 211+252), fill = self.czerwony)	
									

				tlo.paste(obrazek, (0,1440))
		else:
			self.aktyw = 0
			self.pasek = 0

			
		self.stan1 = state['universal1']
		self.stan2 = state['universal2']
		self.stan4 = state['universal4']
		self.stan5 = state['universal5']			
		self.stan6 = state['universal6']							
		return tlo

# globale do komunikatow
activeMessages = []
